# angular2-data-table  [![Join the chat at https://gitter.im/swimlane/angular2-data-table](https://badges.gitter.im/Join%20Chat.svg)](https://gitter.im/swimlane/angular2-data-table?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge) [![Code Climate](https://codeclimate.com/github/swimlane/angular2-data-table/badges/gpa.svg)](https://codeclimate.com/github/swimlane/angular2-data-table) [![Test Coverage](https://codeclimate.com/github/swimlane/angular2-data-table/badges/coverage.svg)](https://codeclimate.com/github/swimlane/angular2-data-table/coverage) [![Dependency Status](https://david-dm.org/swimlane/angular2-data-table.svg)](https://david-dm.org/swimlane/angular2-data-table) [![devDependency Status](https://david-dm.org/swimlane/angular2-data-table/dev-status.svg)](https://david-dm.org/swimlane/angular2-data-table#info=devDependencies) [![npm version](https://badge.fury.io/js/angular2-data-table.svg)](http://badge.fury.io/js/angular2-data-table) [![npm downloads](https://img.shields.io/npm/dm/angular2-data-table.svg)](https://npmjs.org/angular2-data-table)

`angular2-data-table` is a Angular2 component for presenting large and complex data.  It has all the features you would expect from any other table but in a light package with _no external dependencies_. The table was designed to be extremely flexible and light; it doesn't make any assumptions about your data or how you: filter, sort or page it.

It was built for modern browsers using _TypeScript, CSS3 and HTML5_ and Angular `>=2.0.0-rc6`. This is the sister project of the [angular-data-table](https://github.com/swimlane/angular-data-table) that is designed for Angular 1.x.

Check out the [documentation & demos](https://swimlane.gitbooks.io/angular2-data-table/content/) for more information!

## Features
- Handle large data sets ( Virtual DOM )
- Expressive Column Templates
- Horizontal & Vertical Scrolling
- Column Reordering & Resizing
- Client & Server-side Pagination & Sorting
- Intelligent Column Width Algorithms ( Force-fill & Flex-grow )
- Integrated Pager
- Row Selection ( Single & Multi )
- Fixed AND Fluid height
- Left and Right Column Pinning
- Decoupled theme'ing with included Google Material theme
- Light codebase / No external dependencies

## Installation
To use angular2-data-table in your project install it via [npm](https://www.npmjs.com/package/angular2-data-table):
```
npm install --save angular2-data-table
```

## Credits
`angular2-data-table` is a [Swimlane](http://swimlane.com) open-source project; we believe in giving back to the open-source community by sharing some of the projects we build for our application. Swimlane is an automated cyber security operations and incident response platform that enables cyber security teams to leverage threat intelligence, speed up incident response and automate security operations.
